summaryrefslogtreecommitdiff
path: root/test
diff options
context:
space:
mode:
authorMichael Vogt <mvo@ubuntu.com>2014-09-02 15:50:19 +0200
committerMichael Vogt <mvo@ubuntu.com>2014-09-02 16:02:37 +0200
commitc6ee61eab54edf6cc3fbe118d304d72a860e1451 (patch)
tree8ca7fdffd4bc257fd5f90bbb3941e1ff351cca9c /test
parentfb4c76436a88a04d1d9b7e9622e431ed8ab708a6 (diff)
Make Proxy-Auto-Detect check for each host
When doing Acquire::http{,s}::Proxy-Auto-Detect, run the auto-detect command for each host instead of only once. This should make using "proxy" from libproxy-tools feasible which can then be used for PAC style or other proxy configurations. Closes: #759264
Diffstat (limited to 'test')
-rwxr-xr-xtest/integration/test-apt-helper80
1 files changed, 58 insertions, 22 deletions
diff --git a/test/integration/test-apt-helper b/test/integration/test-apt-helper
index 6505b5956..c749224ca 100755
--- a/test/integration/test-apt-helper
+++ b/test/integration/test-apt-helper
@@ -9,31 +9,67 @@ configarchitecture "i386"
changetohttpswebserver
-echo "foo" > aptarchive/foo
+test_apt_helper_download() {
+ echo "foo" > aptarchive/foo
-msgtest 'apt-file download-file md5sum'
-apthelper -qq download-file http://localhost:8080/foo foo2 MD5Sum:d3b07384d113edec49eaa6238ad5ff00 && msgpass || msgfail
-testfileequal foo2 'foo'
+ msgtest 'apt-file download-file md5sum'
+ apthelper -qq download-file http://localhost:8080/foo foo2 MD5Sum:d3b07384d113edec49eaa6238ad5ff00 && msgpass || msgfail
+ testfileequal foo2 'foo'
-msgtest 'apt-file download-file sha1'
-apthelper -qq download-file http://localhost:8080/foo foo1 SHA1:f1d2d2f924e986ac86fdf7b36c94bcdf32beec15 && msgpass || msgfail
-testfileequal foo1 'foo'
+ msgtest 'apt-file download-file sha1'
+ apthelper -qq download-file http://localhost:8080/foo foo1 SHA1:f1d2d2f924e986ac86fdf7b36c94bcdf32beec15 && msgpass || msgfail
+ testfileequal foo1 'foo'
-msgtest 'apt-file download-file sha256'
-apthelper -qq download-file http://localhost:8080/foo foo3 SHA256:b5bb9d8014a0f9b1d61e21e796d78dccdf1352f23cd32812f4850b878ae4944c && msgpass || msgfail
-testfileequal foo3 'foo'
+ msgtest 'apt-file download-file sha256'
+ apthelper -qq download-file http://localhost:8080/foo foo3 SHA256:b5bb9d8014a0f9b1d61e21e796d78dccdf1352f23cd32812f4850b878ae4944c && msgpass || msgfail
+ testfileequal foo3 'foo'
-msgtest 'apt-file download-file no-hash'
-apthelper -qq download-file http://localhost:8080/foo foo4 && msgpass || msgfail
-testfileequal foo4 'foo'
-
-msgtest 'apt-file download-file wrong hash'
-if ! apthelper -qq download-file http://localhost:8080/foo foo5 MD5Sum:aabbcc 2>&1 2> download.stderr; then
- msgpass
-else
- msgfail
-fi
-testfileequal download.stderr 'E: Failed to fetch http://localhost:8080/foo Hash Sum mismatch
+ msgtest 'apt-file download-file no-hash'
+ apthelper -qq download-file http://localhost:8080/foo foo4 && msgpass || msgfail
+ testfileequal foo4 'foo'
+
+ msgtest 'apt-file download-file wrong hash'
+ if ! apthelper -qq download-file http://localhost:8080/foo foo5 MD5Sum:aabbcc 2>&1 2> download.stderr; then
+ msgpass
+ else
+ msgfail
+ fi
+ testfileequal download.stderr 'E: Failed to fetch http://localhost:8080/foo Hash Sum mismatch
E: Download Failed'
-testfileequal foo5.FAILED 'foo'
+ testfileequal foo5.FAILED 'foo'
+}
+
+test_apt_helper_detect_proxy() {
+ # no proxy
+ testequal "Using proxy '' for URL 'http://example.com/'" apthelper auto-detect-proxy http://example.com/
+
+
+ # http auto detect proxy script
+ cat > apt-proxy-detect <<'EOF'
+#!/bin/sh -e
+echo "http://some-proxy"
+EOF
+ chmod 755 apt-proxy-detect
+ echo "Acquire::http::Proxy-Auto-Detect \"$(pwd)/apt-proxy-detect\";" > rootdir/etc/apt/apt.conf.d/02proxy-detect
+
+ testequal "Using proxy 'http://some-proxy' for URL 'http://www.example.com/'" apthelper auto-detect-proxy http://www.example.com
+
+
+ # https auto detect proxy script
+ cat > apt-proxy-detect <<'EOF'
+#!/bin/sh -e
+echo "https://https-proxy"
+EOF
+ chmod 755 apt-proxy-detect
+ echo "Acquire::https::Proxy-Auto-Detect \"$(pwd)/apt-proxy-detect\";" > rootdir/etc/apt/apt.conf.d/02proxy-detect
+
+ testequal "Using proxy 'https://https-proxy' for URL 'https://ssl.example.com/'" apthelper auto-detect-proxy https://ssl.example.com
+
+
+
+}
+
+test_apt_helper_download
+test_apt_helper_detect_proxy
+